package com.assure.core.utils;

import com.assure.core.utils.MockMultipartFile;
import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import com.jcraft.jsch.SftpException;
import com.jcraft.jsch.ChannelSftp.LsEntry;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;
import org.springframework.web.multipart.MultipartFile;

public class SftpUtilPlb {

   public static void main(String[] args) throws JSchException {
      File file = new File("D:\\新建文本文档.txt");
      upload("172.16.31.42", 22, "qnyh", "Aa123456!", "/app/sftp/qnyh/plb/qnyhtoqdrzdb", file);
      System.out.println("ok");
   }

   public static ChannelSftp getSFTPConnect(String host, int port, String username, String password) throws JSchException {
      ChannelSftp sftp = null;
      JSch jsch = new JSch();
      Session sshSession = jsch.getSession(username, host, port);
      sshSession.setPassword(password);
      Properties sshConfig = new Properties();
      sshConfig.put("kex", "diffie-hellman-group-exchange-sha256,diffie-hellman-group14-sha1");
      sshConfig.put("cipher.s2c", "aes128-ctr,aes192-ctr,aes256-ctr");
      sshConfig.put("cipher.c2s", "aes128-ctr,aes192-ctr,aes256-ctr");
      sshConfig.put("PubkeyAcceptedAlgorithms", "ssh-rsa,rsa-sha2-256,rsa-sha2-512");
      sshConfig.put("StrictHostKeyChecking", "no");
      sshSession.setConfig(sshConfig);
      sshSession.connect(6000);
      Channel channel = sshSession.openChannel("sftp");
      channel.connect(5000);
      sftp = (ChannelSftp)channel;
      return sftp;
   }

   public static boolean downloadVagueFileName(String host, int port, String username, String password, String directory, String downloadFile, String saveFile) {
      try {
         ChannelSftp e = getSFTPConnect(host, port, username, password);
         if(e != null) {
            Vector v = e.ls(directory);
            Iterator it = v.iterator();

            while(it.hasNext()) {
               LsEntry entry = (LsEntry)it.next();
               String filename = entry.getFilename();
               if(filename.contains(downloadFile)) {
                  File file = new File(saveFile);
                  File.separator.get(filename, new FileOutputStream(file));
               }
            }
         }

         return true;
      } catch (Exception var13) {
         var13.printStackTrace();
         return false;
      }
   }

   public static boolean upload(String host, int port, String username, String password, String directory, File file) {
      ChannelSftp sftp = null;

      boolean var8;
      try {
         sftp = getSFTPConnect(host, port, username, password);
         if(sftp != null) {
            try {
               Vector e = sftp.ls(directory);
               if(e == null) {
                  mkdirs(directory, sftp);
               }
            } catch (Exception var13) {
               mkdirs(directory, sftp);
            }

            sftp.cd(directory);
            sftp.put(new FileInputStream(file), file.getName());
         }

         return true;
      } catch (Exception var14) {
         var14.printStackTrace();
         var8 = false;
      } finally {
         if(sftp != null) {
            sftp.disconnect();
         }

      }

      return var8;
   }

   public static Boolean download(String host, int port, String username, String password, String targetPath, String fileName, String tempPath) {
      ChannelSftp sftp = null;

      Boolean var9;
      try {
         sftp = getSFTPConnect(host, port, username, password);
         if(sftp != null) {
            sftp.cd(targetPath);
            File e = new File(tempPath);
            sftp.get(fileName, new FileOutputStream(e));
         }

         return Boolean.valueOf(true);
      } catch (Exception var13) {
         var13.printStackTrace();
         if(sftp != null) {
            sftp.disconnect();
         }

         var9 = Boolean.valueOf(false);
      } finally {
         if(sftp != null) {
            sftp.disconnect();
         }

      }

      return var9;
   }

   public static void delete(String deleteFilePath) {
      try {
         File e = new File(deleteFilePath);
         if(e.exists()) {
            e.delete();
         }
      } catch (Exception var2) {
         var2.printStackTrace();
      }

   }

   private static boolean mkdirs(String dir, ChannelSftp sftp) throws SftpException {
      String[] dirArr = dir.split("/");
      String base = "";
      String[] var4 = dirArr;
      int var5 = dirArr.length;

      for(int var6 = 0; var6 < var5; ++var6) {
         String d = var4[var6];
         if(d != null && !"".equals(d) && !dirExist(d, sftp)) {
            sftp.mkdir(d);
         }
      }

      return true;
   }

   public static boolean dirExist(String dir, ChannelSftp sftp) {
      try {
         Vector e = sftp.ls(dir);
         return null != e;
      } catch (SftpException var3) {
         return false;
      }
   }

   public static MultipartFile getMultipartFile(File file) {
      try {
         FileInputStream e = new FileInputStream(file);

         MockMultipartFile var2;
         try {
            var2 = new MockMultipartFile("file", file.getName(), "text/plain", e);
         } catch (Throwable var5) {
            try {
               e.close();
            } catch (Throwable var4) {
               var5.addSuppressed(var4);
            }

            throw var5;
         }

         e.close();
         return var2;
      } catch (Exception var6) {
         throw new IllegalArgumentException(var6, var6);
      }
   }

   public static boolean upload(String host, int port, String username, String password, String directory, InputStream in, String fileName) {
      ChannelSftp sftp = null;

      boolean var9;
      try {
         sftp = getSFTPConnect(host, port, username, password);
         if(sftp != null) {
            try {
               Vector e = sftp.ls(directory);
               if(e == null) {
                  mkdirs(directory, sftp);
               }
            } catch (Exception var14) {
               mkdirs(directory, sftp);
            }

            sftp.cd(directory);
            sftp.put(in, fileName);
         }

         return true;
      } catch (Exception var15) {
         var15.printStackTrace();
         var9 = false;
      } finally {
         if(sftp != null) {
            sftp.disconnect();
         }

      }

      return var9;
   }

   public static byte[] download(String host, int port, String username, String password, String targetPath, String fileName) {
      ChannelSftp sftp = null;
      byte[] result = null;

      try {
         sftp = getSFTPConnect(host, port, username, password);
         if(sftp != null) {
            sftp.cd(targetPath);
            InputStream e = sftp.get(fileName);
            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024];

            int length;
            while((length = e.read(buffer)) != -1) {
               outputStream.write(buffer, 0, length);
            }

            e.close();
            result = outputStream.toByteArray();
            outputStream.close();
         }
      } catch (Exception var15) {
         var15.printStackTrace();
      } finally {
         if(sftp != null) {
            sftp.disconnect();
         }

      }

      return result;
   }

   public static boolean upload(String host, int port, String username, String password, String directory, File file, String fileName) {
      ChannelSftp sftp = null;

      boolean var9;
      try {
         sftp = getSFTPConnect(host, port, username, password);
         if(sftp != null) {
            try {
               Vector e = sftp.ls(directory);
               if(e == null) {
                  mkdirs(directory, sftp);
               }
            } catch (Exception var14) {
               mkdirs(directory, sftp);
            }

            sftp.cd(directory);
            sftp.put(new FileInputStream(file), fileName);
         }

         return true;
      } catch (Exception var15) {
         var15.printStackTrace();
         var9 = false;
      } finally {
         if(sftp != null) {
            sftp.disconnect();
         }

      }

      return var9;
   }
}
